(function() {
  var phone = /((?!(<a href[^<>]*?>|<[^>]*?|<style[^<>]*?>|<script[^<>]*?>))(\+[0-9]+[\- ]*)?(\([0-9]+\)[\-]*)?([0-9][0-9\-][0-9\-]+[0-9]{2,})(?!\.)(?!\d)(?!@)(?!([^<>]*?<\/a>|[^<]*?>|[^<>]*?<\/style>|[^<>]*?<\/script>)))/g;
  var email = /((?!(<a href[^<>]*?>|<[^>]*?))[a-zA-Z0-9\+\.\_\%\-\+]{1,256}\@[a-zA-Z0-9][a-zA-Z0-9\-]{0,64}(\.[a-zA-Z0-9][a-zA-Z0-9\-]{0,25})+(?!([^<>]*?<\/a>|[^<]*?>)))/g;

  // copy webmail 的版本
  //var url = /((?!(<a href[^<>]*?>|<[^>]*?))((?:https?:\/\/|www\d{0,3}[.]|[a-z0-9.\-]+[.][a-z]{2,4}\/)(?:(&amp;amp;)|(&amp;)|[^\s`!()\uff08\uff09\[\]{};'"<>\u201c\u201d\u2018\u2019\u3002\uff0c\uff1b]|([(\uff08][^\s()\uff08\uff09<>]+[)\uff09])|([(\uff08][^\s()\uff08\uff09<>]*?[(\uff08][^\s()\uff08\uff09<>]*?[)\uff09][)\uff09]))+(?:([(\uff08][^\s()\uff08\uff09<>]+[)\uff09])|([(\uff08][^\s()\uff08\uff09<>]*?[(\uff08][^\s()\uff08\uff09<>]*?[)\uff09][)\uff09])|[^\s`!()\uff08\uff09\[\]{};:'".,<>?\u201c\u201d\u2018\u2019\u3002\uff0c\uff1b]))(?!([^<>]*?<\/a>|[^<]*?>)))/g;
  var url = /((?!(<a href[^<>]*?>|<[^>]*?|<style[^<>]*?>|<script[^<>]*?>))((?:https?:\/\/|www\d{0,3}[.]|[a-z0-9.\-]+[.][a-z]{2,4}\/)(?:(&amp;amp;)|(&amp;)|[^\s`!()\uff08\uff09\[\]{};'"<>\u201c\u201d\u2018\u2019\u3002\uff0c\uff1b]|([(\uff08][^\s()\uff08\uff09<>]+[)\uff09])|([(\uff08][^\s()\uff08\uff09<>]*?[(\uff08][^\s()\uff08\uff09<>]*?[)\uff09][)\uff09]))+(?:([(\uff08][^\s()\uff08\uff09<>]+[)\uff09])|([(\uff08][^\s()\uff08\uff09<>]*?[(\uff08][^\s()\uff08\uff09<>]*?[)\uff09][)\uff09])|[^\s`!()\uff08\uff09\[\]{};:'".,<>?\u201c\u201d\u2018\u2019\u3002\uff0c\uff1b]))(?!([^<>]*?<\/a>|[^<]*?>|[^<>]*?<\/style>|[^<>]*?<\/script>)))/g;

  function phoneTransform(content) {
    phone.lastIndex = 0;
    return content.replace(phone, function(m) {
      var c = 0;
      for (var i = 0, l = m.length; i < l; i++) {
        if (/\d/.test(m.charAt(i))) c++;
      }
      if (c >= 5 && c <= 20) {
        var arr = m.split(/(\s|-)/)
        arr = arr.slice(arr.length - 3)
        if (arr.length > 0) {
          for (var i = 0, l = arr.length; i < l; i++) {
            if (arr[i].length > 2) {
              return '<a href="tel:' + m + '">' + m + '</a>';
            }
          }
        } else {
          return '<a href="tel:' + m + '">' + m + '</a>';
        }
      }
      return m;
    });
  }

  function emailTransform(content) {
    email.lastIndex = 0;
    return content.replace(email, '<a href="mailto:$&">$&</a>');
  }

  function urlTransform(content) {
    url.lastIndex = 0;
    return content.replace(url, function(m) {
      if (/^[http|ftp|https]/.test(m)) {
        return '<a href="' + m + '">' + m + '</a>';
      }
      return '<a href="http://' + m + '">' + m + '</a>';
    });
  }

  var content = document.getElementsByTagName('body')[0].innerHTML;

  function autoFormat() {
    //document.cookie="clinet_token=XXXX;domain=192.168.181.6;port=8030;
//    var b = document.createElement('base');
//    b.href = 'xxx.xxx.xxx.xxx:xxx';
//    document.head.appendChild(b);
    content = emailTransform(content);
    content = urlTransform(content);
    content = phoneTransform(content);
    document.getElementsByTagName('body')[0].innerHTML = content;
  }

  window.addEventListener("load", function() {
    autoFormat();
    reScale();
  }, false);

})()